<script setup>
import { computed, ref } from "vue";
import { useStore } from "vuex";
import { minimalObject } from "@utils";
import FoldOut from "@components/Template/FoldOut.vue";
import FormDefault from "@components/Form/FormDefault.vue";
import ModalOverlay from "@components/Template/ModalOverlay.vue";

// Connect to Store and Router
const store = useStore();

defineExpose({
  onVisible: () => {
    store.dispatch("plugins/getAvailable");
    store.dispatch("plugins/getInstalled");
  },
});

store.dispatch("plugins/getAvailable");
store.dispatch("plugins/getInstalled");

// Compute necessary Store values for Component
const installedPlugins = computed(() => store.state.plugins.plugins);
const availablePlugins = computed(() => store.getters["plugins/availablePlugins"]);

// Create local References
const removeItemModal = ref({
  visible: false,
  plugin: null,
  collection: null,
  item: null,
});

// Create local Callback Functions
function setRemoveItemModal({ plugin, collection, item }) {
  removeItemModal.value.plugin = plugin;
  removeItemModal.value.collection = collection;
  removeItemModal.value.item = item;
  removeItemModal.value.visible = true;
}
</script>

<template>
  <!------------------------ PLUGIN  ------------------------>
  <div
    v-for="plugin in installedPlugins"
    :key="plugin.name"
    class="plugin-settings-container"
    :class="[plugin.core ? 'has-background-light' : 'has-background-white']"
  >
    <FoldOut>
      <template #header>
        <nav class="level" :class="[plugin.core ? '' : ' is-interactive']">
          <!-- Left side -->
          <div class="level-left">
            <div class="level-item">
              <h1 class="is-uppercase">{{ plugin.package?.title || plugin.name }}</h1>
            </div>
            <div v-if="plugin.package?.homepage && plugin.package?.homepage != ''" class="level-item">
              <a class="is-flex pl-1" :href="plugin.package?.homepage" target="_blank" rel="noopener noreferrer">
                <Icon class="has-text-grey" :icon="'help-circle'" tooltip="Open Documentation" :interactive="false" />
              </a>
            </div>
          </div>
          <!-- Right side -->
          <div v-if="!plugin.core" class="level-right">
            <!-- <div class="level-item">
              <Icon
                v-if="plugin.connectible"
                class="has-text-black m-1"
                :icon="'plug'"
                :title="`Connect Plugin`"
                @click.stop="
                  {
                  }
                "
              />
            </div>
            <div class="level-item">
              <Icon
                v-if="plugin.connectible"
                class="has-text-black m-1"
                :icon="'unplug'"
                :title="`Disconnect Plugin`"
                @click.stop="
                  {
                  }
                "
              />
            </div> -->
            <div class="level-item">
              <Icon
                v-if="plugin.connectible"
                class="m-1"
                :icon="'circle'"
                :tooltip="`Plugin ${plugin.connected ? 'connected' : 'disconnected'}`"
                :fill="plugin.connected ? 'green' : 'red'"
                :interactive="false"
              />
            </div>
            <div class="level-item">
              <Icon
                :icon="'refresh-cw'"
                :tooltip="'Reload Plugin'"
                class="m-1"
                @click.stop="$store.dispatch('plugins/load', { plugin: plugin.name })"
              />
            </div>
            <div class="level-item">
              <Icon
                :icon="'trash'"
                :tooltip="'Delete Plugin'"
                @click.stop="$store.dispatch('plugins/remove', { plugin: plugin.name })"
              />
            </div>
          </div>
        </nav>
      </template>
      <template #default="{ toggleFold }">
        <!-- <details>
          <summary>DATA</summary>
          <pre>{{ JSON.stringify(plugin, null, 2) }}</pre>
        </details> -->
        <!------------------------ PLUGIN SETTINGS  --------------------------->
        <!-- FIXME: FormDefault does not update when schema Changes might need sth for that-->
        <FormDefault
          v-if="!plugin.core"
          :schema="plugin.settings.schema"
          :data="plugin.settings?.data || {}"
          @on-confirm="
            (data) =>
              $store.dispatch('plugins/updateSettings', {
                plugin: plugin.name,
                data,
              })
          "
          @on-close="toggleFold"
        />
        <!------------------------ PLUGIN COLLECTIONS  ------------------------>
        <br v-if="!plugin.core" />
        <h2 v-if="!plugin.core && plugin.items?.length">ITEMS</h2>
        <div v-for="(value, collection, index) in plugin.items" :key="index" class="ml-2 m-1 p-1">
          <h2 class="is-uppercase">{{ collection }}</h2>
          <!------------------------ PLUGIN ITEMS IN COLLECTION --------------->
          <div
            v-for="(item, itemIndex) in value.items"
            :key="collection + '_item_' + itemIndex"
            class="mb-2 p-2 has-background-blue-4 has-text-black"
          >
            <FoldOut class="has-background-blue-5">
              <template #header>
                <nav class="level">
                  <!-- Left side -->
                  <div class="level-left">
                    <div class="level-item">
                      <p class="">
                        {{ item?.name || `${collection}_${index}` }}
                      </p>
                    </div>
                  </div>
                  <!-- Right side -->
                  <div class="level-right">
                    <p class="level-item">
                      <Icon
                        v-if="item.connectible"
                        class="has-text-black"
                        :icon="'plug'"
                        :title="`Connect Item`"
                        @click.stop="
                          $store.dispatch('plugins/connectItem', {
                            plugin: plugin.name,
                            collection,
                            item: item._id,
                          })
                        "
                      />
                    </p>
                    <p class="level-item">
                      <Icon
                        v-if="item.connectible"
                        class="has-text-black"
                        :icon="'unplug'"
                        :title="`Disconnect Item`"
                        @click.stop="
                          $store.dispatch('plugins/disconnectItem', {
                            plugin: plugin.name,
                            collection,
                            item: item._id,
                          })
                        "
                      />
                    </p>
                    <p class="level-item">
                      <Icon
                        v-if="item.connectible"
                        :icon="'circle'"
                        :tooltip="`Item ${item.connected ? 'connected' : 'disconnected'}`"
                        :fill="item.connected ? 'green' : 'red'"
                      />
                    </p>
                    <p class="level-item">
                      <Icon
                        class="has-text-black"
                        :icon="'refresh-cw'"
                        :title="`Reload Plugin Item`"
                        @click.stop="
                          $store.dispatch('plugins/loadItem', {
                            plugin: plugin.name,
                            collection,
                            item: item._id,
                          })
                        "
                      />
                    </p>
                    <p class="level-item">
                      <Icon
                        :icon="'trash'"
                        :title="`Delete Plugin Item`"
                        class="has-text-black my-2 mr-2"
                        @click.stop="
                          setRemoveItemModal({
                            plugin: plugin.name,
                            collection: collection,
                            item: item._id || item.name,
                          })
                        "
                      />
                    </p>
                  </div>
                </nav>
              </template>
              <template #default="slotPropsItem">
                <FormDefault
                  :schema="value.schema"
                  :data="item"
                  @on-confirm="
                    (data) =>
                      $store.dispatch('plugins/editItem', {
                        plugin: plugin.name,
                        collection: collection,
                        item: item._id,
                        data,
                      })
                  "
                  @on-close="slotPropsItem.toggleFold"
                />
              </template>
            </FoldOut>
          </div>
          <FoldOut class="has-background-blue-5">
            <template #header>
              <button class="button">
                <Icon :icon="'plus-circle'" />
              </button>
            </template>
            <template #default="slotPropsCollection">
              <FormDefault
                :schema="value.schema"
                :data="minimalObject(value.schema)"
                :confirm-on-unmount="false"
                @on-confirm="
                  (data) => {
                    $store.dispatch('plugins/addItem', {
                      plugin: plugin.name,
                      collection: collection,
                      data,
                    });
                    slotPropsCollection.toggleFold();
                  }
                "
                @on-close="slotPropsCollection.toggleFold"
              />
            </template>
          </FoldOut>
          <div></div>
        </div>
      </template>
    </FoldOut>
  </div>
  <!------------------------ ADD PLUGIN LIST --------------------------------->
  <h2 class="m-2 mb-3">AVAILABLE</h2>
  <div v-for="plugin in availablePlugins" :key="plugin">
    <div class="plugin-settings-container has-background-purple-5">
      <nav class="level">
        <!-- Left side -->
        <div class="level-left is-flex-shrink-1">
          <div class="level-item">
            <h1 class="is-uppercase">{{ plugin.title || plugin.name }}</h1>
          </div>
          <div class="level-item is-flex-shrink-1">
            <div class="content is-small">
              {{ plugin.description }}
              <a
                v-if="plugin.homepage && plugin.homepage != ''"
                class=""
                :href="plugin.homepage"
                target="_blank"
                rel="noopener noreferrer"
              >
                More information
              </a>
            </div>
          </div>
        </div>
        <div class="level-right">
          <div class="level-item">
            <Icon
              :icon="'plus-circle'"
              class="has-text-black"
              tooltip="Activate Plugin"
              :interactive="true"
              @click.stop="$store.dispatch('plugins/install', { plugin: plugin.name })"
            />
          </div>
        </div>
      </nav>
    </div>
  </div>
  <!------------------------ DELETE PLUGIN MODAL --------------------------------->
  <ModalOverlay
    v-if="removeItemModal.visible"
    :modal="removeItemModal"
    :css-classes="['is-danger']"
    @close-modal="removeItemModal.visible = false"
  >
    <template #header>Delete Plugin Item {{ removeItemModal.item }}</template>
    <template #default>
      <p>
        Do you really want to delete the {{ removeItemModal.collection }} Item of the plugin
        {{ removeItemModal.plugin }}?
      </p>
    </template>
    <template #footer>
      <button
        class="button is-danger m-1"
        @click="
          $store
            .dispatch('plugins/removeItem', {
              plugin: removeItemModal.plugin,
              collection: removeItemModal.collection,
              item: removeItemModal.item,
            })
            .then(() => (removeItemModal.visible = false))
        "
      >
        DELETE
      </button>
      <button class="button m-1" @click="removeItemModal.visible = false">CANCEL</button>
    </template>
  </ModalOverlay>
</template>
